clear all
close all


fmax=40;%pu essere aumentato a piacere. 
%affinch i grafici nel tempo abbiano un senso
%il dt deve essere scelto opportunamente
%stiamo infatti solo simulando grandezze continue (sia t che f)
dt=1/(fmax*20);%affinch i grafici nel tempo abbiano un senso
%prendo dt inferiore a 10 volte il tempo di campionamento massimo (che
%corrispone alla freq. di Nyquist)

tmax=3;
t=-tmax:dt:tmax;



% %per onda rettangolare decommenta da qui
 T0=1;%periodo
 T=0.1;%tempo con onda rettangolare a valore alto
 duty=100*T/T0;
 %tra 0 e fmax ci stanno queste componenti
 n_max=floor(fmax/(1/T0));
f=[-n_max:n_max]*1/T0;
x=0.5+0.5*square(2*pi*(t+T/2)/T0,duty);
% 
 X_n=T/T0*sinc(f*T/T0);%  ovviamente discreto 
% 
% %%%% a qui

% 
% % %per onda triangolare decommenta da qui
%  T0=1;%periodo
%   %tra 0 e fmax ci stanno queste componenti
%  n_max=floor(fmax/(1/T0));
% f=[-n_max:n_max]*1/T0;
% x=0.5+0.5*sawtooth(2*pi*(t-T0/2)/T0,0.5);
% % 
%  X_n=0.5*(sinc(0.5*f)).^2;%  ovviamente discreto 
% % 
% % %%%% a qui



f1=figure;
set(f1,'Position',[1 1 1200 800])
ctrl.esiste_linea=0;
ctrl.X_n=X_n;
ctrl.f=f;
ctrl.t=t;
ctrl.x=x;
ctrl.step_f=1/T0;
set(f1,'UserData',ctrl);
s1=subplot(3,1,1);
p1=plot(t,x);
xlabel('t');ylabel('x(t)')
%axis([n(1) n(end) -2*sum(x_n) 2*sum(x_n)])
set(p1,'LineWidth',2);
s2=subplot(3,1,2);
p2=stem(f,abs(X_n));
axis([f(1) f(end) 0 1.05*max(abs(X_n))])
xlabel('f');ylabel('|Xn|')

s3=subplot(3,1,3);

p3=stem(f,angle(X_n));
axis([f(1) f(end) -pi pi])
xlabel('f');ylabel('fase(Xn)')


hpop1 = uicontrol('Style', 'pushbutton',...
       'String', 'aumenta f  ',...
       'Position', [100 500 70 30],...
       'Callback', 'aumentaf');
hpop2 = uicontrol('Style', 'pushbutton',...
       'String', 'dimin f ',...
       'Position', [20 500 70 30],...
       'Callback', 'diminf');
   

