clear all
close all

N=50;

n=-N:N;
a=0.5;
T=0.1;

df=0.0001;
f=-2/(T):df:2/(T);
f=f+(f==0)*eps;


%per impulso rettangolare decommenta da qui
x_n=zeros(1,2*N+1);
x_n(49:53)=1;
X_f=sin(pi*5*f*T)./sin(pi*f*T);
not_numb=find(isnan(X_f));
X_f(not_numb)=5;
%%%% a qui

% %per esponenziale monolatero decommenta da qui
% x_n=a.^n.*(n>=0);
% X_f=1./(1-a*exp(-j*2*pi*f*T));
% %a qui


f1=figure;
set(f1,'Position',[1 1 1200 800])
ctrl.esiste_linea=0;
ctrl.X_f=X_f;
ctrl.f=f;
ctrl.df=df;
ctrl.T=T;
ctrl.n=n;
ctrl.x_n=x_n;
ctrl.step_f=f(end)/80;
set(f1,'UserData',ctrl);
s1=subplot(3,1,1);
p1=stem(n,x_n);
xlabel('n');ylabel('x[n]')


set(p1,'LineWidth',2);
s2=subplot(3,1,2);
p2=plot(f,abs(X_f));
axis([f(1) f(end) 0 1.05*max(abs(X_f))])
xlabel('f');ylabel('|X(f)|')


s3=subplot(3,1,3);

p3=plot(f,angle(X_f));
axis([f(1) f(end) -pi pi])
xlabel('f');ylabel('fase(X(f))')


hpop1 = uicontrol('Style', 'pushbutton',...
       'String', 'aumenta f  ',...
       'Position', [100 500 70 30],...
       'Callback', 'aumentaf');
hpop2 = uicontrol('Style', 'pushbutton',...
       'String', 'dimin f ',...
       'Position', [20 500 70 30],...
       'Callback', 'diminf');
   
   hpop3 = uicontrol('Style', 'pushbutton',...
       'String', 'aum step f  ',...
       'Position', [100 550 70 30],...
       'Callback', 'aumentastep');
hpop4 = uicontrol('Style', 'pushbutton',...
       'String', 'dim step f ',...
       'Position', [20 550 70 30],...
       'Callback', 'diminstep');
   subplot(3,1,3);
   t1=title(['step f =', num2str(ctrl.step_f)]);

   

