clear all
close all


fmax=2;%pu essere aumentato a piacere. 
%affinch i grafici nel tempo abbiano un senso
%il dt deve essere scelto opportunamente
%stiamo infatti solo simulando grandezze continue (sia t che f)
dt=1/(fmax*20);%affinch i grafici nel tempo abbiano un senso
%prendo dt inferiore a 10 volte il tempo di campionamento massimo (che
%corrispone alla freq. di Nyquist)

tmax=10;
t=-tmax:dt:tmax;
df=0.0001;
f=-fmax:df:fmax;
f=f+(f==0)*eps;


% %per impulso rettangolare decommenta da qui
 T=5; %durata rect 
x=rectpuls(t,T);
% 
 X_f=T*sinc(f*T);
% 
% %%%% a qui


% %per impulso triangolare decommenta da qui
 T=5; %durata rect 
x=tripuls(t,T);
% 
 X_f=T*(sinc(f*T/2)).^2;
% 
% %%%% a qui




f1=figure;
set(f1,'Position',[1 1 1200 800])
ctrl.esiste_linea=0;
ctrl.X_f=X_f;
ctrl.f=f;
ctrl.df=df;
ctrl.T=T;
ctrl.t=t;
ctrl.x=x;
ctrl.step_f=f(end)/80;
set(f1,'UserData',ctrl);
s1=subplot(3,1,1);
p1=plot(t,x);
xlabel('t');ylabel('x(t)')


set(p1,'LineWidth',2);
s2=subplot(3,1,2);
p2=plot(f,abs(X_f));
axis([f(1) f(end) 0 1.05*max(abs(X_f))])
xlabel('f');ylabel('|X(f)|')


s3=subplot(3,1,3);

p3=plot(f,angle(X_f));
axis([f(1) f(end) -pi pi])
xlabel('f');ylabel('fase(X(f))')



hpop1 = uicontrol('Style', 'pushbutton',...
       'String', 'aumenta f  ',...
       'Position', [100 500 70 30],...
       'Callback', 'aumentaf');
hpop2 = uicontrol('Style', 'pushbutton',...
       'String', 'dimin f ',...
       'Position', [20 500 70 30],...
       'Callback', 'diminf');
   
   hpop3 = uicontrol('Style', 'pushbutton',...
       'String', 'aum step f  ',...
       'Position', [100 550 70 30],...
       'Callback', 'aumentastep');
hpop4 = uicontrol('Style', 'pushbutton',...
       'String', 'dim step f ',...
       'Position', [20 550 70 30],...
       'Callback', 'diminstep');
   subplot(3,1,3);
   t1=title(['step f =', num2str(ctrl.step_f)]);
  

